---
title: WebGL2RenderingContext.getBufferSubData()
slug: Web/API/WebGL2RenderingContext/getBufferSubData
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.getBufferSubData()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> reads data from a buffer binding point and writes them to an {{jsxref("ArrayBuffer")}} or {{jsxref("SharedArrayBuffer")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void gl.getBufferSubData(target, srcByteOffset, ArrayBufferView dstData, optional dstOffset, optional length);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.ARRAY_BUFFER</code>: Buffer containing vertex attributes, such as vertex coordinates, texture coordinate data, or vertex color data.</li>
  <li><code>gl.ELEMENT_ARRAY_BUFFER</code>: Buffer used for element indices.</li>
  <li><code>gl.COPY_READ_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
  <li><code>gl.COPY_WRITE_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
  <li><code>gl.TRANSFORM_FEEDBACK_BUFFER</code>: Buffer for transform feedback operations.</li>
  <li><code>gl.UNIFORM_BUFFER</code>: Buffer used for storing uniform blocks.</li>
  <li><code>gl.PIXEL_PACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
  <li><code>gl.PIXEL_UNPACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
 </ul>
 </dd>
 <dt><code>srcByteOffset</code></dt>
 <dd>A {{domxref("GLintptr")}} specifying the byte offset from which to start reading from the buffer.</dd>
 <dt><code>dstData</code></dt>
 <dd>An {{jsxref("ArrayBuffer")}} or {{jsxref("SharedArrayBuffer")}} to which to write the buffer data.</dd>
 <dt>srcOffset {{optional_inline}}</dt>
 <dd>A {{domxref("GLuint")}} specifying the element index offset where to start reading the buffer.</dd>
 <dt><code>length</code> {{optional_inline}}</dt>
 <dd>A {{domxref("GLuint")}} defaulting to 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>An <code>INVALID_VALUE</code> error is generated if:</p>

<ul>
 <li><code>offset</code> + <code>returnedData.byteLength </code>would extend beyond the end of the buffer</li>
 <li><code>returnedData</code> is {{jsxref("null")}}</li>
 <li><code>offset</code> is less than zero.</li>
</ul>

<p>An <code>INVALID_OPERATION</code> error is generated if:</p>

<ul>
 <li>zero is bound to <code>target</code></li>
 <li><code>target</code> is <code>TRANSFORM_FEEDBACK_BUFFER</code>, and any transform feedback object is currently active.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var buffer = gl.createBuffer();
gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.STATIC_DRAW);

var arrBuffer = new ArrayBuffer(vertices.length * Float32Array.BYTES_PER_ELEMENT);
gl.getBufferSubData(gl.ARRAY_BUFFER, 0, arrBuffer);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.3", "getBufferSubData")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.getBufferSubData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.bufferData()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bufferSubData()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getBufferParameter()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.copyBufferSubData()")}}</li>
</ul>
